# terraform-module-aws-s3-bucket

Generic module create a S3 bucket, kms encrypted, with 2 base policies that allow read only and full right access.

## Limitations

- When creating policies for multiple entities, use `var.identity_export_jsons` instead to compose your own policy.

<!-- BEGIN_TF_DOCS -->
## Requirements

| Name | Version |
|------|---------|
| terraform | >= 1.9 |
| aws | >= 5.78 |

## Providers

| Name | Version |
|------|---------|
| aws | >= 5.78 |

## Modules

| Name | Source | Version |
|------|--------|---------|
| iam\_policy\_identity\_based | gitlab.com/wild-beavers/module-aws-iam-policy/aws | ~> 1 |
| iam\_policy\_resource\_based | gitlab.com/wild-beavers/module-aws-iam-policy/aws | ~> 1 |
| kms | gitlab.com/wild-beavers/module-aws-kms/aws | ~> 2 |

## Resources

| Name | Type |
|------|------|
| [aws_s3_access_point.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/s3_access_point) | resource |
| [aws_s3_account_public_access_block.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/s3_account_public_access_block) | resource |
| [aws_s3_bucket.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/s3_bucket) | resource |
| [aws_s3_bucket_acl.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/s3_bucket_acl) | resource |
| [aws_s3_bucket_cors_configuration.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/s3_bucket_cors_configuration) | resource |
| [aws_s3_bucket_lifecycle_configuration.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/s3_bucket_lifecycle_configuration) | resource |
| [aws_s3_bucket_logging.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/s3_bucket_logging) | resource |
| [aws_s3_bucket_object_lock_configuration.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/s3_bucket_object_lock_configuration) | resource |
| [aws_s3_bucket_ownership_controls.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/s3_bucket_ownership_controls) | resource |
| [aws_s3_bucket_policy.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/s3_bucket_policy) | resource |
| [aws_s3_bucket_public_access_block.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/s3_bucket_public_access_block) | resource |
| [aws_s3_bucket_request_payment_configuration.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/s3_bucket_request_payment_configuration) | resource |
| [aws_s3_bucket_server_side_encryption_configuration.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/s3_bucket_server_side_encryption_configuration) | resource |
| [aws_s3_bucket_versioning.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/s3_bucket_versioning) | resource |
| [aws_s3_bucket_website_configuration.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/s3_bucket_website_configuration) | resource |
| [aws_s3control_access_point_policy.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/s3control_access_point_policy) | resource |
| [aws_caller_identity.current](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/data-sources/caller_identity) | data source |
| [aws_iam_policy_document.tls](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/data-sources/iam_policy_document) | data source |
| [aws_region.current](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/data-sources/region) | data source |

## Inputs

| Name | Description | Type | Default | Required |
|------|-------------|------|---------|:--------:|
| access\_points | To manage an S3 Access Points.<br/>Keys are free values.<br/><br/>- name                                     (optional, string): Name of the access point.<br/>- account\_id                               (optional, string): AWS account ID for the owner of the bucket for which you want to create an access point. Defaults to automatically determined account ID of the Terraform AWS provider.<br/>- bucket\_account\_id                        (optional, string): AWS account ID associated with the S3 bucket associated with this access point.<br/>- policy                                   (optional, string): Valid JSON document that specifies the policy that you want to apply to this access point.<br/>- vpc\_configuration\_vpc\_id                 (optional, string): Restrict access to this access point to requests from the specified Virtual Private Cloud (VPC). If not set, the access point will be considered public.<br/>- public\_configuration\_block\_public\_acls   (optional, bool): Whether Amazon S3 should block public ACLs for this access point. Defaults to `true`. Enabling this setting does not affect existing policies or ACLs. When set to `true` causes the following behavior:<br/>    PUT Bucket acl and PUT Object acl calls fail if the specified ACL is public.<br/>    PUT Object calls fail if the request includes a public ACL.<br/>    PUT Bucket calls fail if the request includes a public ACL.<br/>- public\_configuration\_block\_public\_policy     (optional, bool): Whether Amazon S3 should block public bucket policies for this access point. Defaults to `true`. Enabling this setting does not affect existing bucket policies. When set to `true` causes Amazon S3 to: Reject calls to PUT Bucket policy if the specified bucket policy allows public access.<br/>- public\_configuration\_ignore\_public\_acls      (optional, bool): Whether Amazon S3 should ignore public ACLs for this access point. Defaults to `true`. Enabling this setting does not affect the persistence of any existing ACLs and doesn't prevent new public ACLs from being set. When set to `true` causes Amazon S3 to: Ignore all public ACLs on buckets in this account and any objects that they contain.<br/>- public\_configuration\_restrict\_public\_buckets (optional, bool): Whether Amazon S3 should restrict public bucket policies for this access point. Defaults to `true`. Enabling this setting does not affect previously stored bucket policies, except that public and cross-account access within any public bucket policy, including non-public delegation to specific accounts, is blocked. When set to `true`: Only the bucket owner and AWS Services can access buckets with public policies. | <pre>map(map(object({<br/>    name                                         = optional(string)<br/>    account_id                                   = optional(string)<br/>    bucket_account_id                            = optional(string)<br/>    policy                                       = optional(string)<br/>    vpc_configuration_vpc_id                     = optional(string)<br/>    public_configuration_block_public_acls       = optional(bool, true)<br/>    public_configuration_block_public_policy     = optional(bool, true)<br/>    public_configuration_ignore_public_acls      = optional(bool, true)<br/>    public_configuration_restrict_public_buckets = optional(bool, true)<br/>  })))</pre> | `{}` | no |
| account\_public\_access\_block | Manages S3 account-level Public Access Block configuration.<br/><https://docs.aws.amazon.com/AmazonS3/latest/dev/access-control-block-public-access.html><br/>Each AWS account may only have one S3 Public Access Block configuration. Multiple configurations of the resource against the same AWS account will cause a perpetual difference.<br/><br/>- block\_public\_acls       (optional, bool, false): Whether Amazon S3 should block public ACLs for buckets in this account.<br/>- block\_public\_policy     (optional, bool, false): Whether Amazon S3 should block public bucket policies for buckets in this account.<br/>- ignore\_public\_acls      (optional, bool, false): Whether Amazon S3 should ignore public ACLs for buckets in this account.<br/>- restrict\_public\_buckets (optional, bool, false): Whether Amazon S3 should restrict public bucket policies for buckets in this account. | <pre>object({<br/>    block_public_acls       = optional(bool, false)<br/>    block_public_policy     = optional(bool, false)<br/>    ignore_public_acls      = optional(bool, false)<br/>    restrict_public_buckets = optional(bool, false)<br/>  })</pre> | `null` | no |
| buckets | List of S3 buckets to create. Keys are free value.<br/>- name                                (required, string): Name of the bucket to create.<br/>- acl                                 (optional, string, "private"): The canned ACL to apply: <https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/s3_bucket_acl><br/>- block\_public\_acls                   (optional, bool, false): Whether Amazon S3 should block public ACLs for this bucket.<br/>- block\_public\_policy                 (optional, bool, false): Whether Amazon S3 should block public bucket policies for this bucket.<br/>- bucket\_key\_enabled                  (optional, bool, false): Whether or not to use Amazon S3 Bucket Keys for SSE-KMS.<br/>- bucket\_object\_ownership             (optional, string, "BucketOwnerPreferred"): Object ownership. Valid values: `BucketOwnerPreferred`: Objects uploaded to the bucket change ownership to the bucket owner if the objects are uploaded with the `bucket-owner-full-control` canned ACL or `ObjectWriter`: The uploading account will own the object if the object is uploaded with the `bucket-owner-full-control` canned ACL or `BucketOwnerEnforced` Bucket owner automatically owns and has full control over every object in the bucket. ACLs no longer affect permissions to data in the S3 bucket.<br/>- expected\_bucket\_owner               (optional, string, null): The account ID of the expected bucket owner.<br/>- force\_destroy                       (optional, boolean, false): When set to `true`, calling a deletion of the bucket will work even if the bucket is *not* empty.<br/>- ignore\_public\_acls                  (optional, bool, false): Whether Amazon S3 should ignore public ACLs for this bucket.<br/>- policy\_json\_enabled                 (optional, bool, false): Whether `json_policy` below is empty or full. Because Terraform catastrophic handling of null values.<br/>- policy\_json                         (optional, string, null): A valid bucket policy JSON document to be applied to the specific bucket. Careful, this comes in complement of IAM entities passed to this module.<br/>- request\_payment\_configuration\_payer (optional, string, "BucketOwner"): Specifies who pays for the download and request fees. Can be either “BucketOwner” or “Requester”.<br/>- restrict\_public\_buckets             (optional, bool, false): Whether Amazon S3 should restrict public bucket policies for this bucket.<br/>- sse\_enabled                         (optional, bool, true): Whether or not to enable server-side encryption. It will use a KMS key created in this module - or external KMS if provided - otherwise, it will use the S3 default encryption.<br/>- tags                                (optional, map, {}): Tags to apply to the specific bucket, in addition to `var.tags` and `var.bucket_tags`. | <pre>map(object({<br/>    name                                = string<br/>    acl                                 = optional(string, "private")<br/>    block_public_acls                   = optional(bool, true)<br/>    block_public_policy                 = optional(bool, true)<br/>    bucket_key_enabled                  = optional(bool, false)<br/>    bucket_object_ownership             = optional(string, "BucketOwnerPreferred")<br/>    expected_bucket_owner               = optional(string)<br/>    force_destroy                       = optional(bool, false)<br/>    ignore_public_acls                  = optional(bool, true)<br/>    policy_json_enabled                 = optional(bool, false)<br/>    policy_json                         = optional(string)<br/>    request_payment_configuration_payer = optional(string, "BucketOwner")<br/>    restrict_public_buckets             = optional(bool, true)<br/>    sse_enabled                         = optional(bool, true)<br/>    tags                                = optional(map(string), {})<br/>  }))</pre> | `{}` | no |
| buckets\_require\_secure\_transport | Whether to enforce TLS-only connections to the S3 bucket. | `bool` | `true` | no |
| buckets\_tags | Map of tags that will be added on the bucket object. | `map(string)` | `{}` | no |
| cors\_configurations\_rules | List of CORS configuration rules for the buckets. See <https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/s3_bucket_cors_configuration><br/>Keys MUST correspond to `var.buckets` keys.<br/><br/>- allowed\_headers (optional, list(string)): Set of Headers that are specified in the `Access-Control-Request-Headers` header.<br/>- allowed\_methods (optional, list(string)): Set of HTTP methods that you allow the origin to execute. Valid values are `GET`, `PUT`, `HEAD`, `POST`, and `DELETE`.<br/>- allowed\_origins (optional, list(string)): Set of origins you want customers to be able to access the bucket from.<br/>- expose\_headers  (optional, list(string)): Set of headers in the response that you want customers to be able to access from their applications (for example, from a JavaScript XMLHttpRequest object).<br/>- id              (optional, string): Unique identifier for the rule. The value cannot be longer than 255 characters.<br/>- max\_age\_seconds (optional, number): The time in seconds that your browser is to cache the preflight response for the specified resource. | <pre>map(list(object({<br/>    allowed_headers = optional(list(string))<br/>    allowed_methods = optional(list(string))<br/>    allowed_origins = optional(list(string))<br/>    expose_headers  = optional(list(string))<br/>    id              = optional(string)<br/>    max_age_seconds = optional(number)<br/>  })))</pre> | `{}` | no |
| current\_account\_id | The account where this module is run. If not provided, will be fetched dynamically. If given, this value is trusted and will not be checked against the real current account ID. | `string` | `""` | no |
| current\_region | The region where this module is run. If not provided, will be fetched dynamically. If given, this value is trusted and will not be checked against the real current region. | `string` | `""` | no |
| iam\_policy\_entity\_arns | Restrict access to the key to the given IAM entities (roles or users). Wildcards are allowed. Allowed keys are `ro`, `rw`, `rwd`, `audit` or `full`, each specifying the permission scope for entities inside them. If the same entity is inside multiple scope, the least privileged scope takes precedence over the most privileged. | `map(map(string))` | `{}` | no |
| iam\_policy\_export\_actions | Whether or not to export IAM policies actions. A lightweight way to generate your own policies. | `bool` | `false` | no |
| iam\_policy\_export\_json | Whether or not to export IAM policies as JSON. | `bool` | `false` | no |
| iam\_policy\_identity | Identity-based IAM Policies to create.<br/>Only policies fitting resource-based user-provided scopes (`ro`, `rw` and `full`) will be created.<br/>    - name\_template           (required, string):           Name template of the IAM Policies. Expect a `%s` to be replace with the user-provided scope (`ro`, `rw` and `full`).<br/>    - description\_template    (required, string):           Description template of the IAM Policies. Expect a `%s` to be replace with the user-provided scope (`ro`, `rw` and `full`).<br/>    - path                    (optional, string, "/"):      Path of the IAM Policies.<br/>    - tags                    (optional, map(string), {}):  Tags of the IAM Policies. Will be merged with `var.tags`. | <pre>object({<br/>    name_template        = string<br/>    description_template = string<br/>    path                 = optional(string, "/")<br/>    tags                 = optional(map(string), {})<br/>  })</pre> | `null` | no |
| iam\_policy\_restrict\_by\_account\_ids | Restrict resources created by this module by the given account IDs. Internal policies will whitelist given list. If `null`, no restriction will be applied. Especially useful when IAM entities contains accounts wildcards. | `list(string)` | `[]` | no |
| iam\_policy\_restrict\_by\_regions | Restrict resources created by this module by the given regions. Internal policies will whitelist given list. If `null`, no restriction will be applied. Especially useful when IAM entities contains region wildcards. | `list(string)` | `[]` | no |
| iam\_policy\_sid\_prefix | Use a prefix for all `Sid` of all the policies created by this module. | `string` | `""` | no |
| iam\_policy\_source\_arns | Restrict access to the key to the given ARN sources. Wildcards are allowed. Allowed keys are `ro`, `rw`, `rwd` or `full`, each specifying the expected level of access for entities inside. | `map(map(string))` | `{}` | no |
| iam\_policy\_source\_policy\_documents | JSON to concatenate to create the external policies. | `list(string)` | `[]` | no |
| identity\_iam\_policy\_document | Information specific for the identity-based Policy documents.<br/>Mandatory if `var.identity_iam_policy`, but might be used solely in combination with `var.identity_export_jsons`.<br/>If entities were provided (through `var.entity_arns` or `var.source_arns`), only identity-based policies documents matching the scopes will be generated.<br/>Otherwise, one policy document per user-provided scopes (keys of `var.scoped_actions`) will be generated.<br/>  - source\_policy\_documents        (optional, list(string), []):      List of JSON strings to be concatenated to the polices. The same as `var.source_policy_documents` but exclusive to identity-based policies.<br/>  - scoped\_source\_policy\_documents (optional, map(list(string)), []): List of JSON strings to be concatenated to the polices, but scoped.<br/>  - resources\_arns                 (optional(list(string), []):       ARNs of resources created outside this module to compose the identity-based IAM Policies with. The same as `var.resources_arns` but exclusive to identity-based policies. | <pre>object({<br/>    source_policy_documents        = optional(list(string), [])<br/>    scoped_source_policy_documents = optional(map(list(string)), {})<br/>    resources_arns                 = optional(list(string), [])<br/>  })</pre> | `null` | no |
| internal\_policy\_attachment\_enabled | Whether to attach internal policies to the buckets. May be disabled for cycle reasons. If disabled, the policy JSON will be outputted in the `bucket_internal_policies` output. | `bool` | `true` | no |
| kms\_grants | Grants to create.<br/>Keys are free values.<br/><br/>  - name                  (required, string):       A friendly name for identifying the grant.<br/>  - grantee\_principal     (required, string):       The principal that is given permission to perform the operations that the grant permits in ARN format. Note that due to eventual consistency issues around IAM principals, terraform’s state may not always be refreshed to reflect what is true in AWS.<br/>  - operations            (required, list(string)): A list of operations that the grant permits. The permitted values are: `Decrypt`, `Encrypt`, `GenerateDataKey`, `GenerateDataKeyWithoutPlaintext`, `ReEncryptFrom`, `ReEncryptTo`, `Sign`, `Verify`, `GetPublicKey`, `CreateGrant`, `RetireGrant`, `DescribeKey`, `GenerateDataKeyPair`, or `GenerateDataKeyPairWithoutPlaintext`.<br/>  - retiring\_principal    (optional, string):       The principal that is given permission to retire the grant by using RetireGrant operation in ARN format. Note that due to eventual consistency issues around IAM principals, terraform’s state may not always be refreshed to reflect what is true in AWS.<br/>  - grant\_creation\_tokens (optional, list(string)): A list of grant tokens to be used when creating the grant. See Grant Tokens for more information about grant tokens.<br/>  - retire\_on\_delete      (optional, bool):         If set to false (the default) the grants will be revoked upon deletion, and if set to true the grants will try to be retired upon deletion. Note that retiring grants requires special permissions, hence why we default to revoking grants. See RetireGrant for more information. | <pre>map(map(object({<br/>    name                  = string<br/>    grantee_principal     = string<br/>    operations            = list(string)<br/>    retiring_principal    = optional(string)<br/>    grant_creation_tokens = optional(list(string))<br/>    retire_on_delete      = optional(bool, false)<br/>  })))</pre> | `{}` | no |
| kms\_key | Options of the KMS key to create.<br/>If given, `var.kms_key_id` will be ignored.<br/><br/>  - alias                   (required, string):      KMS key alias; Display name of the KMS key. Omit the `alias/`.<br/>  - policy\_json             (optional, string):      Additional policy to attach to the KMS key, merged with a baseline internal policy. Make sure to provide "var.iam\_admin\_arns" to avoid getting blocked.<br/>  - description             (optional, string, ""):  Description of the key.<br/>  - rotation\_enabled        (optional, bool, true):  Whether to automatically rotate the KMS key linked to the S3.<br/>  - deletion\_window\_in\_days (optional, number, 7):   The waiting period, specified in number of days. After the waiting period ends, AWS KMS deletes the KMS key. If you specify a value, it must be between `7` and `30`, inclusive. If you do not specify a value, it defaults to `7`.<br/>  - tags                    (optional, map(string)): Tags to be used by the KMS key of this module. | <pre>object({<br/>    alias                   = string<br/>    policy_json             = optional(string, null)<br/>    description             = optional(string, "")<br/>    rotation_enabled        = optional(bool, true)<br/>    deletion_window_in_days = optional(number, 7)<br/>    tags                    = optional(map(string), {})<br/>  })</pre> | `null` | no |
| kms\_key\_id | ARN or ID (or alias) of the AWS KMS customer master key (CMK) to be used to encrypt the resources data. If you don’t specify this value or `var.kms_key`, then S3 defaults to using the AWS account’s default S3 SSE. | `string` | `null` | no |
| lifecycle\_configuration\_default\_rules | Lifecycle default rules configurations for the buckets, according to AWS best practices. Enabled by default, pass an empty list to disable. | <pre>list(object({<br/>    id     = string<br/>    status = optional(string, "Enabled")<br/>    abort_incomplete_multipart_upload = optional(object({<br/>      days_after_initiation = number<br/>    }))<br/>    expiration = optional(object({<br/>      date                         = optional(string)<br/>      days                         = optional(number)<br/>      expired_object_delete_marker = optional(bool)<br/>    }))<br/>    filter = optional(object({<br/>      and = optional(map(object({<br/>        object_size_greater_than = optional(number)<br/>        object_size_less_than    = optional(number)<br/>        prefix                   = optional(string)<br/>        tags                     = optional(map(string))<br/>      })))<br/>    }))<br/>    noncurrent_version_expiration = optional(object({<br/>      newer_noncurrent_versions = optional(number)<br/>      noncurrent_days           = optional(number)<br/>    }))<br/>    noncurrent_version_transition = optional(object({<br/>      newer_noncurrent_versions = optional(number)<br/>      noncurrent_days           = optional(number)<br/>      storage_class             = string<br/>    }))<br/>    transition = optional(object({<br/>      date          = optional(string)<br/>      days          = optional(number)<br/>      storage_class = string<br/>    }))<br/>  }))</pre> | <pre>[<br/>  {<br/>    "abort_incomplete_multipart_upload": {<br/>      "days_after_initiation": 7<br/>    },<br/>    "id": "abort_incomplete_multipart_upload",<br/>    "status": "Enabled"<br/>  }<br/>]</pre> | no |
| lifecycle\_configurations\_rules | Lifecycle rules configurations for the buckets. See <https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/s3_bucket_lifecycle_configuration> for more details.<br/>Keys MUST correspond to `var.buckets` keys.<br/><br/>  - id                                (required, string): Unique identifier for the rule. The value cannot be longer than 255 characters.<br/>  - status                            (optional, string, "Enabled"): Whether the rule is currently being applied. Valid values: `Enabled` or `Disabled`.<br/>  - abort\_incomplete\_multipart\_upload (optional, object): Configuration block that specifies the days since the initiation of an incomplete multipart upload that Amazon S3 will wait before permanently removing all parts of the upload.<br/>     - days\_after\_initiation (required, number): The number of days after which Amazon S3 aborts an incomplete multipart upload.<br/>  - expiration (optional, object): Configuration block that specifies the expiration for the lifecycle of the object in the form of date, days and, whether the object has a delete marker<br/>     - date                         (optional, string): The date the object is to be moved or deleted. Should be in GMT ISO 8601 Format. e.g. `2023-01-13T00:00:00Z`.<br/>     - days                         (optional, number): The lifetime, in days, of the objects that are subject to the rule. The value must be a non-zero positive integer.<br/>     - expired\_object\_delete\_marker (optional, bool): Indicates whether Amazon S3 will remove a delete marker with no noncurrent versions. If set to `true`, the delete marker will be expired; if set to `false` the policy takes no action. Conflicts with `date` and `days`.<br/>  - filter (optional, object): Configuration block used to identify objects that a Lifecycle Rule applies to.<br/>      - and (optional, list(object)): Configuration block used to apply a logical `AND` to two or more predicates. The Lifecycle Rule will apply to any object matching all the predicates configured inside the `and` block.<br/>      - object\_size\_greater\_than (optional, number): Minimum object size to which the rule applies. Value must be at least `0` if specified.<br/>      - object\_size\_less\_than    (optional, number): Maximum object size to which the rule applies. Value must be at least `1` if specified.<br/>      - prefix                   (optional, string): Prefix identifying one or more objects to which the rule applies.<br/>      - tag                      (optional, map(string)): Key-value map of resource tags. All of these tags must exist in the object’s tag set in order for the rule to apply.<br/>  - noncurrent\_version\_expiration (optional, object): Configuration block that specifies when noncurrent object versions expire.<br/>     - newer\_noncurrent\_versions (optional, number): The number of noncurrent versions Amazon S3 will retain.<br/>     - noncurrent\_days           (optional, number): The number of days an object is noncurrent before Amazon S3 can perform the associated action. Must be a positive integer.<br/>  - noncurrent\_version\_transition (optional, object): Set of configuration blocks that specify the transition rule for the lifecycle rule that describes when noncurrent objects transition to a specific storage class<br/>     - newer\_noncurrent\_versions (optional, number): The number of noncurrent versions Amazon S3 will retain.<br/>     - noncurrent\_days           (optional, number): The number of days an object is noncurrent before Amazon S3 can perform the associated action. Must be a positive integer.<br/>     - storage\_class             (required, string): The class of storage used to store the object. Valid Values: `GLACIER`, `STANDARD_IA`, `ONEZONE_IA`, `INTELLIGENT_TIERING`, `DEEP_ARCHIVE`, `GLACIER_IR`.<br/>  - transition (optional, object): Set of configuration blocks that specify the transition rule for the lifecycle rule that describes when noncurrent objects transition to a specific storage class<br/>    - date          (optional, string): The date objects are transitioned to the specified storage class. The date value must be in ISO 8601 format and set to midnight UTC e.g. `2023-01-13T00:00:00Z`.<br/>    - days          (optional, number): The number of days after creation when objects are transitioned to the specified storage class. The value must be a positive integer. If both `days` and `date` are not specified, defaults to `0`. Valid values depend on `storage_class`.<br/>    - storage\_class (required, string): The class of storage used to store the object. Valid Values: `GLACIER`, `STANDARD_IA`, `ONEZONE_IA`, `INTELLIGENT_TIERING`, `DEEP_ARCHIVE`, `GLACIER_IR`. | <pre>map(list(object({<br/>    id     = string<br/>    status = optional(string, "Enabled")<br/>    abort_incomplete_multipart_upload = optional(object({<br/>      days_after_initiation = number<br/>    }))<br/>    expiration = optional(object({<br/>      date                         = optional(string)<br/>      days                         = optional(number)<br/>      expired_object_delete_marker = optional(bool)<br/>    }))<br/>    filter = optional(object({<br/>      and = optional(map(object({<br/>        object_size_greater_than = optional(number)<br/>        object_size_less_than    = optional(number)<br/>        prefix                   = optional(string)<br/>        tags                     = optional(map(string))<br/>      })))<br/>    }))<br/>    noncurrent_version_expiration = optional(object({<br/>      newer_noncurrent_versions = optional(number)<br/>      noncurrent_days           = optional(number)<br/>    }))<br/>    noncurrent_version_transition = optional(object({<br/>      newer_noncurrent_versions = optional(number)<br/>      noncurrent_days           = optional(number)<br/>      storage_class             = string<br/>    }))<br/>    transition = optional(object({<br/>      date          = optional(string)<br/>      days          = optional(number)<br/>      storage_class = string<br/>    }))<br/>  })))</pre> | `{}` | no |
| logging\_configurations | Configure logging on buckets objects. It is highly recommended to use logging for good security practice.<br/>Keys MUST correspond to `var.buckets` keys.<br/><br/> - target\_bucket (required, string): The bucket where you want Amazon S3 to store server access logs.<br/> - target\_prefix (required, string): A prefix for all log object keys.<br/> - target\_grant  (optional, object): Granting permissions. See <https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/s3_bucket_logging#target_grant>. | <pre>map(object({<br/>    target_bucket = string<br/>    target_prefix = string<br/>    target_grant = optional(object({<br/>      grantee = object({<br/>        email_address = optional(string)<br/>        id            = optional(string)<br/>        type          = string<br/>        uri           = optional(string)<br/>      })<br/>      permission = string<br/>    }))<br/>  }))</pre> | `{}` | no |
| object\_lock\_configurations | Configure an object lock configuration on the buckets objects. See <https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/s3_bucket_object_lock_configuration>.<br/>Keys MUST correspond to `var.buckets` keys.<br/><br/>- rule (required, object): The bucket where you want Amazon S3 to store server access logs.<br/>  - default\_retention (required, object): The bucket where you want Amazon S3 to store server access logs.<br/>    - mode  (required, string): The default Object Lock retention mode you want to apply to new objects placed in the specified bucket. Valid values: `COMPLIANCE`, `GOVERNANCE`.<br/>    - days  (optional, number): The number of days that you want to specify for the default retention period. Required if `years` is not specified.<br/>    - years (optional, number): The number of years that you want to specify for the default retention period. Required if `days` is not specified. | <pre>map(object({<br/>    rule = object({<br/>      default_retention = object({<br/>        mode  = string<br/>        days  = optional(number)<br/>        years = optional(number)<br/>      })<br/>    })<br/>  }))</pre> | `{}` | no |
| tags | Tags that will be shared with all the resources of this module | `map(string)` | `{}` | no |
| testing\_prefix | Prefix to be used for all resources names. Specifically useful for tests. A 4-characters alphanumeric string. It must start by a lowercase letter. | `string` | `""` | no |
| versioning\_configurations | Configurations for the versioning of the buckets. Once you enable versioning on a bucket, it can never return to an un-versioned state. You can, however, suspend versioning on that bucket.<br/>Keys MUST correspond to `var.buckets` keys.<br/><br/> - status (required, bool):               The versioning state of the bucket. `true` for `Enabled`, `false` for `Suspended`.<br/> - mfa\_delete (optional, bool):           Specifies whether MFA delete is enabled in the bucket versioning configuration. Valid values: `true` for `Enabled` or `false` for `Disabled`.<br/> - versioning\_mfa (optional, string, ""): The concatenation of the authentication device’s serial number, a space, and the value that is displayed on your authentication device. Required if `mfa_delete` is `Enabled`. | <pre>map(object({<br/>    status         = bool<br/>    mfa_delete     = optional(bool)<br/>    versioning_mfa = optional(string, "")<br/>  }))</pre> | `{}` | no |
| website\_configurations | Website configurations for the buckets. See <https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/s3_bucket_website_configuration#index_document> for more details.<br/>Keys MUST correspond to `var.buckets` keys.<br/><br/> - index\_document           (optional, object): The name of the index document for the website. Conflicts with `redirect_all_requests_to`.<br/>   - suffix (required, string): A suffix that is appended to a request that is for a directory on the website endpoint. For example, if the suffix is `index.html` and you make a request to `samplebucket/images/`, the data that is returned will be for the object with the key name `images/index.html`. The suffix must not be empty and must not include a slash character.<br/> - error\_document           (optional, object): The name of the error document for the website. Conflicts with `redirect_all_requests_to`.<br/>   - key (required, string): The object key name to use when a 4XX class error occurs.<br/> - redirect\_all\_requests\_to (optional, object): Granting permissions. See <https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/s3_bucket_logging#target_grant>.<br/>   - host\_name (required, string): Name of the host where requests are redirected.<br/>   - protocol  (optional, string): Protocol to use when redirecting requests. The default is the protocol that is used in the original request. Valid values: `http`, `https`.<br/> - routing\_rule             (optional, object): List of rules that define when a redirect is applied and the redirect behavior. Conflicts with `redirect_all_requests_to`.<br/>   - condition (optional, object): Condition that must be met for the specified redirect to apply.<br/>     - http\_error\_code\_returned\_equals (optional, string): The HTTP error code when the redirect is applied. If specified with key\_prefix\_equals, then both must be true for the redirect to be applied. Required if `key_prefix_equals` is not specified.<br/>     - key\_prefix\_equals               (optional, string): The object key name prefix when the redirect is applied. If specified with `http_error_code_returned_equals`, then both must be true for the redirect to be applied. Required if `http_error_code_returned_equals` is not specified.<br/>   - redirect  (required, object): Redirect information.<br/>     - host\_name               (optional, string): The host name to use in the redirect request.<br/>     - http\_redirect\_code      (optional, string): The HTTP redirect code to use on the response.<br/>     - protocol                (optional, string): Protocol to use when redirecting requests. The default is the protocol that is used in the original request. Valid values: `http`, `https`.<br/>     - replace\_key\_prefix\_with (optional, string): The object key prefix to use in the redirect request. For example, to redirect requests for all pages with prefix `docs/` (objects in the `docs/` folder) to `documents/`, you can set a condition block with `key_prefix_equals` set to `docs/` and in the redirect set `replace_key_prefix_with` to `/documents`. Conflicts with `replace_key_with`.<br/>     - replace\_key\_with        (optional, string): The specific object key to use in the redirect request. For example, redirect request to `error.html`. Conflicts with `replace_key_prefix_with`. | <pre>map(object({<br/>    index_document = optional(object({<br/>      suffix = string<br/>    }))<br/>    error_document = optional(object({<br/>      key = string<br/>    }))<br/>    redirect_all_requests_to = optional(object({<br/>      host_name = string<br/>      protocol  = optional(string)<br/>    }))<br/>    routing_rule = optional(object({<br/>      condition = optional(object({<br/>        http_error_code_returned_equals = optional(string)<br/>        key_prefix_equals               = optional(string)<br/>      }))<br/>      redirect = optional(object({<br/>        host_name               = optional(string)<br/>        http_redirect_code      = optional(string)<br/>        protocol                = optional(string)<br/>        replace_key_prefix_with = optional(string)<br/>        replace_key_with        = optional(string)<br/>      }))<br/>    }))<br/>  }))</pre> | `{}` | no |

## Outputs

| Name | Description |
|------|-------------|
| aws\_iam\_policies | n/a |
| aws\_kms\_alias | n/a |
| aws\_kms\_grants | n/a |
| aws\_kms\_key | n/a |
| aws\_s3\_access\_point | n/a |
| aws\_s3\_bucket\_website\_configurations | n/a |
| aws\_s3\_buckets | n/a |
| kms\_aws\_iam\_policies | n/a |
| precomputed | n/a |
<!-- END_TF_DOCS -->
